#ifndef CoCoA_OnlineHelp_H
#define CoCoA_OnlineHelp_H

//   Copyright (c)  2010  Anna Bigatti

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.

#include <string>
//using std::string;
#include <vector>
//using std::vector;


namespace CoCoA
{
namespace OnlineHelp
{
  
  class index
  {
  public: 
    class entry
    {
    public:
      entry(const std::string& title): myTitleValue(title) {}
      // ~entry(); // default is OK
      const std::string& myTitle() const {return myTitleValue;}
      const std::vector<std::string> myKeys() const {return myKeysValue;}
      void myAddKey(const std::string& key);

    private: // data members
      std::string myTitleValue;
      std::vector<std::string> myKeysValue;
    };
 
  public:
    index();
    // ~index(); // default is OK
    //    void myLoad();
    const std::string& myTitle(std::size_t i) const {return myVec[i].myTitle();}
    const std::vector<std::string> myKeys(std::size_t i) const {return myVec[i].myKeys();}
    std::size_t mySize() const {return myVec.size();}

  private:
    void myAddEntry(std::ifstream& in, const std::string& title, const std::string& ClosingTag);
  
  private: // data members
    std::vector<entry> myVec;
  };

  void PrintMan(const std::string& s, std::ostream &out);
  const char* XMLFileName();

} // namespace OnlineHelp
} // namespace CoCoA


// RCS header/log in the next few lines
// $Header: /Volumes/Home_1/cocoa/cvs-repository/CoCoALib-0.99/src/CoCoA-5/OnlineHelp.H,v 1.5 2010/09/01 13:24:48 bigatti Exp $
// $Log: OnlineHelp.H,v $
// Revision 1.5  2010/09/01 13:24:48  bigatti
// -- moved all manual functions into CoCoA::OnlineHelp namespace
//
// Revision 1.4  2010/09/01 12:27:52  lagorio
// *** empty log message ***
//
// Revision 1.3  2010/09/01 07:46:19  lagorio
// *** empty log message ***
//
// Revision 1.2  2010/08/31 14:55:58  bigatti
// -- added cvs log
//

#endif
